$AMI_Event_Handler{'bridgepopup'}{'UNLINK'} = sub {
    my $event = shift;
    my @allreturn;

    my $state = ${$event}{'Bridgestate'};
    my $uni1 = ${$event}{'Uniqueid1'};
    my $uni2 = ${$event}{'Uniqueid2'};
    $canal1  = FOP2::utils::get_channel(${$event}{Channel1});
    $canal2 = FOP2::utils::get_channel(${$event}{Channel2});

    # Asterisk might send an extra Link event after an unlink, causing duplicate popups
    # So we save state of unlinks channels to prevent double popups, and clear them on 
    # hangup event to avoid memory leaks. Not so nice but it works.

    if($state eq "Unlink") {
        $main::pluginvariable{'bridgepopup'}{'pendingunlink'}{$canal1} = 1;
        $main::pluginvariable{'bridgepopup'}{'pendingunlink'}{$canal2} = 1;
    }
    return @allreturn;
};

$AMI_Event_Handler{'bridgepopup'}{'LINK'} = sub {
    my $event = shift;
    my @allreturn;

    my $state = ${$event}{'Bridgestate'};
    my $uni1  = ${$event}{'Uniqueid1'};
    my $uni2  = ${$event}{'Uniqueid2'};
    $canal1   = FOP2::utils::get_channel(${$event}{Channel1});
    $canal2   = FOP2::utils::get_channel(${$event}{Channel2});

    if($state eq "Link") {

        if(!defined($main::pluginvariable{'bridgepopup'}{'pendingunlink'}{$canal1})) {
            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: CustomPopup\r\n";
            $return .= "Channel: $canal1\r\n";
            $return .= "Family: setvar\r\n";
            $return .= "Value: ". FOP2::utils::encode_base64("UNIQUEID=".$uni1). "\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: CustomPopup\r\n";
            $return .= "Channel: $canal1\r\n";
            $return .= "Family: notifyconnect\r\n";
            $return .= "Value: $canal2\r\n";
            $return .= "\r\n";
            push @allreturn, $return;
        } 

        if(!defined($main::pluginvariable{'bridgepopup'}{'pendingunlink'}{$canal2})) {
            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: CustomPopup\r\n";
            $return .= "Channel: $canal2\r\n";
            $return .= "Family: setvar\r\n";
            $return .= "Value: ". FOP2::utils::encode_base64("UNIQUEID=".$uni2). "\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: CustomPopup\r\n";
            $return .= "Channel: $canal2\r\n";
            $return .= "Family: notifyconnect\r\n";
            $return .= "Value: $canal1\r\n";
            $return .= "\r\n";
            push @allreturn, $return;
        } 

    } 
    
    return @allreturn;
};

$AMI_Event_Handler{'bridgepopup'}{'HANGUP'} = sub {
    my $event = shift;
    my @allreturn;
    $canal  = FOP2::utils::get_channel(${$event}{Channel});
    delete $main::pluginvariable{'bridgepopup'}{'pendingunlink'}{$canal};
    return @allreturn;
}
